package net.cave.sortHolic;

import java.util.ArrayList;

/*
 * ソートのアルゴリズムは
 * http://www.ics.kagoshima-u.ac.jp/~fuchida/edu/algorithm/sort-algorithm/quick-sort.html
 * を参照しました。
 * 
 */

public class QuickSort implements Sort {

	public int[] a;
	ArrayList<int[]> list;
        
    QuickSort(int[] b) {	// コンストラクタ
    	a = b.clone();
    	list = new ArrayList<int[]>();
    	list.add(b.clone());
    }
    
	public int[] getArr() {
		return a;
	}

	public int[] getArr(int step) {
		return list.get(step);
	}


	public void sort() {
		sort(0, a.length-1);
	}
	
    private int pivot(int i,int j){
        int k=i+1;
        while(k<=j && a[i]==a[k]) k++;
        if(k>j) return -1;
        if(a[i]>=a[k]) return i;
        return k;
    }

      /*
       * パーティション分割
       * a[i]〜a[j]の間で、x を軸として分割。
       * x より小さい要素は前、大きい要素は後。
       */
    int partition(int i,int j,int x){
    	int l=i,r=j;
        // 交差するまでリピート
        while(l<=r){
        	while(l<=j && a[l]<x)  l++;
        	while(r>=i && a[r]>=x) r--;

        	if(l>r) break;
        	int t=a[l];
        	a[l]=a[r];
        	a[r]=t;
        	l++; r--;
    	    list.add(a.clone());
        }
        return l;
    }
    public void sort(int i,int j){
        if(i==j) return;
        int p=pivot(i,j);
        if(p!=-1){
        	int k=partition(i,j,a[p]);
        	sort(i,k-1);
        	sort(k,j);
        }
    }	
}
